<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;

class SugestaoVendaTipo extends CrudWithParameterBag{
    
    const TABLE = 'SUGESTAOTIPO';
    const CAMPO_PK = 'IDSUGESTAOTIPO';
    
    protected $dataSourceName = 'confTelaSugestaoTipo';
    protected $parameterBagColumns = array("NRORG","IDSUGESTAOTIPO");
    protected $novoCodigo;
    protected $dataSourceManager;
    protected $parameterBag;
    protected $util;
     
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, $novoCodigo, $util) {
        $this->novoCodigo  = $novoCodigo;
        $this->util = $util;
        parent::__construct($dataSourceManager, $parameterBag);
    }
    
    public function save (DTO\Request\DataSet $request, DTO\Response $response){
        $row = $this->util->getParamsAsArray($request);
        if(count($row)){
            parent::save($this->setCodigo($request,$row),$response);
        }
    }
    
    private function setCodigo ($request, $rows){
        foreach ($rows as $key => $row) {
            if($row['__is_new']){
                $novoCodigo = $this->novoCodigo->getCodeByTableName(self::TABLE,$row['NRORG'],1,null,false);
                $request->getDataSet()->getRows()[$key]->set(self::CAMPO_PK, $novoCodigo);
            }
        }
        return $request;
    }
}