<?php
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Doctrine\DBAL\Connection;

class CancelamentoZeramentoSaldoService {

    /**
     * ExtratoCons  /Credito/
     */

    protected $connection;
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function GetSaldoNegativos($conditions){
    	$params = array(
    		':CDCLIENTE' =>  $conditions['CDCLIENTE'],
    		':DTMOVEXTCONS' =>  $conditions['DTMOVEXTCONS'],
    		':DSOPEEXTCONS' =>  $conditions['DSOPEEXTCONS'],
    		':IDTPMOVEXT' =>  $conditions['IDTPMOVEXT'],
    		':CDTIPOCONS' =>  $conditions['CDTIPOCONS'],
    		':NRORG' => $conditions['NRORG'] 
    	);
    	return $this->connection->fetchAll(self::GET_NEG_SALDO, $params);
    }

    public function GetNextNrseqmovext($conditions){
    	$params = array(
    		':CDCLIENTE' =>  $conditions['CDCLIENTE'],
    		':CDCONSUMIDOR' =>  $conditions['CDCONSUMIDOR'],
    		':CDFAMILISALD' =>  $conditions['CDFAMILISALD'],
    		':DTMOVEXTCONS' =>  $conditions['DTMOVEXTCONS'],
    		':NRORG' => $conditions['NRORG'] 
    	);
    	return $this->connection->fetchAll(self::GET_NEXT_NRSEQMOVEXT, $params);
    }

    public function insertCancelaZeramento ($conditions){
    	$params = array(
    		':CDCLIENTE' =>  $conditions['CDCLIENTE'],
    		':CDCONSUMIDOR' =>  $conditions['CDCONSUMIDOR'],
    		':CDFAMILISALD' =>  $conditions['CDFAMILISALD'],
    		':DTMOVEXTCONS' =>  $conditions['DTMOVEXTCONS'],
    		':NRSEQMOVEXT' =>  $conditions['NRSEQMOVEXT'],
    		':CDTIPORECE' =>  $conditions['CDTIPORECE'],
    		':DSOPEEXTCONS' =>  $conditions['DSOPEEXTCONS'],
    		':VRMOVEXTCONS' =>  $conditions['VRMOVEXTCONS'],
    		':VRSALDCONEXT' =>  $conditions['VRSALDCONEXT'],
    		':IDTPMOVEXT' =>  $conditions['IDTPMOVEXT'],
    		':IDIMPEXTCONS' =>  $conditions['IDIMPEXTCONS'],
    		':IDCANZERASALD' =>  $conditions['IDCANZERASALD'],
    		//':DTULTATUEXT' => $conditions['DTULTATUEXT'], ( SysDate )
            ':NRSEQREGCREDVND' => $conditions['NRSEQREGCREDVND'],
            //':IDIMPEXTRATO' => $conditions['IDIMPEXTRATO'], ( Fixo 'S' )
    		':CDFILIAL' => $conditions['CDFILIAL'],
    		':NRORG' => $conditions['NRORG']
    	);
    	return $this->connection->executeQuery(self::INSERT_CANCEL_ZERAMENTO, $params);
    }

    public function atualizaExtratoCons($conditions){
        $conditions['DTMOVEXTCONS'] = explode( ' ', $conditions['DTMOVEXTCONS'])[0];
    	$params = array(
    		':CDCLIENTE' =>  $conditions['CDCLIENTE'],
    		':CDCONSUMIDOR' =>  $conditions['CDCONSUMIDOR'],
    		':CDFAMILISALD' =>  $conditions['CDFAMILISALD'],
    		':DTMOVEXTCONS' =>  $conditions['DTMOVEXTCONS'],
    		':NRORG' => $conditions['NRORG']
    	);
    	return $this->connection->executeQuery(self::UPADATE_EXTRATO_CONS, $params);
    }


    const GET_NEG_SALDO = "
    	SELECT EX.CDCLIENTE, EX.CDCONSUMIDOR, EX.CDFAMILISALD, EX.DTMOVEXTCONS, EX.DSOPEEXTCONS, EX.VRMOVEXTCONS, EX.CDTIPORECE, EX.NRORG
      	  FROM EXTRATOCONS EX
      	  JOIN CONSUMIDOR CON 
      	    ON EX.NRORG        = CON.NRORG
      	   AND EX.CDCLIENTE    = CON.CDCLIENTE
           AND EX.CDCONSUMIDOR = CON.CDCONSUMIDOR
      	 WHERE EX.DSOPEEXTCONS  					  = :DSOPEEXTCONS
      	   AND EX.CDCLIENTE     					  = :CDCLIENTE
      	   AND EX.IDTPMOVEXT    					  = :IDTPMOVEXT
      	   AND TO_CHAR(EX.DTMOVEXTCONS, 'dd/mm/YYYY') = :DTMOVEXTCONS
           AND EX.NRORG						   	 	  = :NRORG
           AND CON.CDTIPOCONS  						  = :CDTIPOCONS
           AND EX.IDCANZERASALD <> 'S'
         GROUP BY EX.CDCLIENTE, EX.CDCONSUMIDOR, EX.CDFAMILISALD,EX.DTMOVEXTCONS ,EX.DSOPEEXTCONS , EX.VRMOVEXTCONS, EX.CDTIPORECE, EX.NRORG
    ";

    const GET_NEXT_NRSEQMOVEXT = "
		SELECT LPAD((NVL(MAX(NRSEQMOVEXT),0) + 1), 3, '0') AS NRSEQMOVEXT
		FROM EXTRATOCONS
		WHERE CDCLIENTE    = :CDCLIENTE
		  AND CDCONSUMIDOR = :CDCONSUMIDOR
		  AND CDFAMILISALD = :CDFAMILISALD
		  AND DTMOVEXTCONS = :DTMOVEXTCONS
		  AND NRORG 		 = :NRORG
    ";

    const INSERT_CANCEL_ZERAMENTO = "
		INSERT INTO EXTRATOCONS(CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, DTMOVEXTCONS, NRSEQMOVEXT, CDTIPORECE, DSOPEEXTCONS, VRMOVEXTCONS,
								VRSALDCONEXT, IDTPMOVEXT, IDIMPEXTCONS, IDCANZERASALD, DTULTATUEXT, NRSEQREGCREDVND, IDIMPEXTRATO, CDFILIAL, NRORG)
      	VALUES (:CDCLIENTE, :CDCONSUMIDOR, :CDFAMILISALD, :DTMOVEXTCONS, :NRSEQMOVEXT, :CDTIPORECE, :DSOPEEXTCONS, :VRMOVEXTCONS,
              	:VRSALDCONEXT, :IDTPMOVEXT, :IDIMPEXTCONS, :IDCANZERASALD, SYSDATE, :NRSEQREGCREDVND, 'S', :CDFILIAL, :NRORG)
    ";

    const UPADATE_EXTRATO_CONS = "
    	UPDATE EXTRATOCONS SET IDCANZERASALD = 'S'
    	 WHERE CDCLIENTE = :CDCLIENTE
		   AND CDCONSUMIDOR = :CDCONSUMIDOR
		   AND CDFAMILISALD = :CDFAMILISALD
	  	   AND DSOPEEXTCONS = 'Zeramento do Saldo'
	  	   AND TO_CHAR(DTMOVEXTCONS,'DD/MM/YYYY') = :DTMOVEXTCONS
    	   AND NRORG = :NRORG
    ";
} 